unit Palette;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ExtCtrls, Grids, DirOutln, ComCtrls,
  ShellCtrls, ImgList, StdCtrls, FileCtrl, Jpeg, PngImage;

type
  TF_Palette = class(TForm)
    Bevel1: TBevel;
    Image1: TImage;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    ShellTreeView1: TShellTreeView;
    Bevel2: TBevel;
    P_CList: TListView;
    ImageList1: TImageList;
    _DirFiles: TFileListBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure ShellTreeView1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    _ChipList : TFileStream; // Chip̃TlC摜ێptmpt@C
    _ChipName : TStringList; // Chip̃t@Cێp
    _ChipPos  : Array of Integer; // Chip̃TlC摜ʒup
  end;

var
  F_Palette: TF_Palette;

implementation

//uses Canvas;

{$R *.dfm}

// http://delfusa.main.jp/delfusafloor/archive/www.nifty.ne.jp_forum_fdelphi/samples/01332.html
// http://www1.cncm.ne.jp/~ogawate/delphi/samples/thumbnail/01.html
// http://homepage3.nifty.com/m-and-i/tips/thumbnl.htm
// http://www.dt8.jp/cgi-bin/sb/sb.cgi?eid=243

procedure TF_Palette.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//  F_Canvas.Tool_VPalette.Down := False; // F_Canvasɂ\{^𐧌
end;

procedure TF_Palette.FormCreate(Sender: TObject);
begin
//  _ChipList := TFileStream.Create('ChipList.tmp', fmCreate);
//  _ChipName := TStringList.Create;

  P_CList.DoubleBuffered := True; // P_CList ̕`̂}
end;

procedure TF_Palette.ShellTreeView1Click(Sender: TObject);
var
  _ImgChk : TPicture;
  _tmp    : TBitmap;
  _Rect   : TRect;

  _i : Integer;
begin
  _Rect := Rect(0, 0,
                P_CList.LargeImages.Width, P_CList.LargeImages.Height);
  _tmp := TBitmap.Create;
  _tmp.Width  := P_CList.LargeImages.Width;
  _tmp.Height := P_CList.LargeImages.Height;

  _DirFiles.Directory := ShellTreeView1.Path; // IꂽpX̃t@Cꗗl

  P_CList.Items.Clear;
//  _ChipList.Size := 0;
//  SetLength(_ChipPos, _DirFiles.Items.Count);

  ImageList1.Clear;

  _ImgChk := TPicture.Create;
  _ImgChk.Bitmap.Canvas.Brush.Color := P_CList.Color;
  for _i := 0 to _DirFiles.Items.Count - 1 do
  begin
//    _ChipPos[_i] := -1; // 摜ʒu-1i摜j[
    _tmp.Canvas.FillRect(Rect(0,0,_tmp.Width,_tmp.Height));
    try
      _ImgChk.LoadFromFile(ShellTreeView1.Path + '\' + _DirFiles.Items[_i]);
    except
      Continue;
    end;

    if (_ImgChk.Width  > P_CList.LargeImages.Width) or
       (_ImgChk.Height > P_CList.LargeImages.Height) then
      _tmp.Canvas.StretchDraw(_Rect, _ImgChk.Graphic)
    else
      _tmp.Canvas.Draw(Trunc((_tmp.Width  - _ImgChk.Width)  / 2 + 0.5),
                       Trunc((_tmp.Height - _ImgChk.Height) / 2 + 0.5),
                       _ImgChk.Graphic);

    P_CList.Items.Add.Caption := _DirFiles.Items[_i]; // t@C[
{
    if _ImgChk.Graphic.ClassType = TPngObject then
showmessage('PNG')
    else
showmessage('other');
}
    P_CList.Items.Item[P_CList.Items.Count - 1].ImageIndex
      := ImageList1.Add(_tmp, nil);

    _ImgChk.Bitmap.FreeImage;
    _tmp.FreeImage;
  end;
  _ImgChk.Free;
  _tmp.Free;
end;

end.
